/*
* Copyright (C) 2001, 2002, 2003, 2004  K. M. Indlekofer
*
* M.Indlekofer@fz-juelich.de
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/



#ifdef WIN32
/* e.g. VC++ */

#include "winlib_cmios9.h"

#else /* !WIN32 */
/* e.g. UNIX-like systems or cygwin */

#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <limits.h>
#include <unistd.h>
#include <strings.h>
#include <string.h>
#include <ctype.h>
#include <time.h>

#endif /* !WIN32 */



#include "cmios9_err.h"



char errbuf[ERRBUFSIZ+1]; /* +1 for terminating '\0' */



void
err_reset(void)
{

	errbuf[0]='\0';
}

void
err_print(char *s)
{

	if (s==NULL){
		return;
	}
#if defined(ERRDIRECT)||defined(DEBUG)
	fprintf(stderr,s);
#else
	strncat(errbuf,s,ERRBUFSIZ-strlen(errbuf));
#endif
}

void
err_output(FILE *fp)
{

	if (fp==NULL){
		return;
	}
	if (strlen(errbuf)==0){
		return;
	}
	fprintf(fp,errbuf);
}



/* EOF */
